<?php
/**
 * Created by PhpStorm.
 * User: rafaelpickbrenne
 * Date: 27/01/14
 * Time: 10:23
 */

namespace Folha\Facade\Relatorios;


class Folha {
    /**
     * Verifica se os fields estão corretamente preenchidos de acordo com o relatório selecionado
     * pck 27/01/2013
     */
    public static function verificaFields() {
        switch(tk_get_field_value('REPORT_NAME')) {  //Nome do relatório
            case '':    //Nenhum relatório selecionado
                tk_abort('Nenhum relatório selecionado.');
                break;
            case 'ficha_financeira':
//                if(tk_get_field_value('ANO') == null || tk_get_field_value('NRVINCULO') == null)
//                    tk_abort('É necessário informar o Ano e o Vínculo para emitir este relatório');
                if(tk_get_field_value('ANO') == null || tk_get_field_value('TIPOMOVIMENTO') == null || tk_get_field_value('MODALIDADECAL') == null)
                    tk_abort('É necessário informar o Tipo de Movimnento, a Modalidade de Cálculo (Cenário) e o Ano para emitir este relatório');
                break;
            case 'ficha_financeira_migracao':
                if(tk_get_field_value('ANO') == null || tk_get_field_value('MODALIDADECAL') == null)
                    tk_abort('É necessário informar a Modalidade de Cálculo (Cenário) e o Ano para emitir este relatório');
                break;
            case 'resumo_folha':
                if(tk_get_field_value('TIPOMOVIMENTO') == null)
                    tk_abort('É necessário informar o Tipo de Movimento para emitir este relatório');
                break;
            case 'ficha_financeira_analitica':
                if(tk_get_field_value('ANO') == null)
                    tk_abort('É necessário informar o Ano para emitir este relatório');
                break;
            case 'demonstrativo_pagamento_lab02':
            case 'demonstrativo_pagamento_laser':
            case 'folha_analitica':
                if(tk_get_field_value('TIPOMOVIMENTO') == null || tk_get_field_value('MODALIDADECAL') == null)
                    tk_abort('É necessário informar o Tipo de Movimnento e a Modalidade de Cálculo (Cenário) para emitir o demonstrativo');
                break;
            case 'ficha_financeira_grade':
                if(tk_get_field_value('TIPOMOVIMENTO') == null || tk_get_field_value('MODALIDADECAL') == null || tk_get_field_value('DATAINICIO') == null || tk_get_field_value('DATAFINAL') == null)
                    tk_abort('É necessário informar o Tipo de Movimento, a Modalidade de Cálculo (Cenário) e as Datas de Inicio e Fim do período em questão para emitir este relatório');
                break;
            case 'liquido':
            case 'liquidocaixa':
            case 'liquidobanco':
			case 'liquidobanco_por_banco':
                if(tk_get_field_value('TIPOMOVIMENTO') == null || tk_get_field_value('MODALIDADECAL') == null || tk_get_field_value('EVENTO') == null)
                    tk_abort('É necessário informar o Tipo de Movimnento, a Modalidade de Cálculo (Cenário) e o Número do Evento para emitir este relatório');
                break;
            case 'lancamentos_evento_vinculo':
                if(tk_get_field_value('TIPOMOVIMENTO') == null || tk_get_field_value('MODALIDADECAL') == null || tk_get_field_value('EVENTO') == null)
                    tk_abort('É necessário informar o Tipo de Movimnento, a Modalidade de Cálculo (Cenário) e Número do Evento para emitir este relatório');
                break;
            case 'comparacao_calculos_folha':
                if(tk_get_field_value('CALCULO1') == null || tk_get_field_value('CALCULO2') == null)
                    tk_abort('É necessário informar os Números de Cálculos para emitir este relatório');
                break;
            //Relatórios que não possuem parâmetros obrigatórios
            case 'eventos_relacionados_vinculo':
                break;
            default:
                tk_abort('Este relatório não está integrado');
        }
    }
} 