<?php

require_once 'base/GepTipofluxoEntityBase.php';

/**
 * GepTipoFluxoEntity.
 *
 * @package Entity
 * @author  tarcisiopereira <username@example.com>
 */
class GepTipofluxoEntity extends GepTipofluxoEntityBase
{


    const SEM_REGISTRO = 10;


    /**
     * Gera novo c?o de Tipo de Fluxo.
     *
     * @param integer $nrorg N?o da Organiza?.
     *
     * @return $codigo integer
     */
    public static function retornaProxNumeroTipoFluxo($nrorg){
        $codigo = Novocodigo::geraCodigo($nrorg, 'GEP_TIPOFLUXO', 10);
        return $codigo;
    }


    /**       ok
     * Retorna os parametros do tipo de fluxo informado.
     *
     * @param integer $nrorg       Numero da organizacao.
     * @param integer $nrtipofluxo Numero do tipo de fluxo.
     *
     * @return Ambigous <Ambigous, mixed, NULL>
     */
    public static function retornaParametrosTipoFluxo($nrorg, $nrtipofluxo){
        $dados = GepTipofluxo::buscaParametrosTipoFluxo($nrorg, $nrtipofluxo);

        if ($dados instanceof GepTipofluxoEntity) {
            return $dados;
        }

        throw new Exception("GepTipofluxoEntity: Nao ha registro para este tipo de fluxo.", self::SEM_REGISTRO);
    }


    /**
     * Retorna a consulta de parceiros de negocio de um ou mais tipos de parceria que se encontram em um tipo de fluxo.
     *
     * @return string $dados       Resultado da query
     */
    public static function buscaParceirosPorTipoFluxo($nrorg, $tipofluxo){
        $sql =  GepTipoFluxo::buscaParceirosPorTipoFluxo($nrorg, $tipofluxo);
        return $sql;
    }


    static function verificaAcesso($nrorg, $tipofluxo, $parceiro){
        $resultado = GepTipofluxo::verificaAcessoTipoFluxo($nrorg, $tipofluxo, $parceiro);
        if (count($resultado[0]) === true)
            return $resultado;
        else
            return false;
    }
}