/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_SVOP                                                     */
/* Tabela : SERVOPER                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_SVOP'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_SVOP
GO

CREATE TRIGGER DTULTATU_SVOP
ON SERVOPER
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'SERVOPER', CDFILIAL, 'CDFILIAL='  + CDFILIAL  + ';'+
                                             'CDOPERADOR='+ CDOPERADOR+ ';'+
                                             'CDSERVFILI='+ CDSERVFILI+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE SERVOPER
      SET DTULTATUSVOP = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(SERVOPER.CDSERVFILI,0) = ISNULL(INSERTED.CDSERVFILI,0)) AND
            (ISNULL(SERVOPER.CDFILIAL,0)   = ISNULL(INSERTED.CDFILIAL,0))   AND
            (ISNULL(SERVOPER.CDOPERADOR,0) = ISNULL(INSERTED.CDOPERADOR,0));
   END;
END;
GO

