IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'STATUS_LOTECTB_BAIXARECEBIDA'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER STATUS_LOTECTB_BAIXARECEBIDA
GO

CREATE TRIGGER STATUS_LOTECTB_BAIXARECEBIDA ON BAIXARECEBIDA
FOR DELETE
AS
DECLARE @V_CDLOTE            VARCHAR(20);
DECLARE @V_NRLANCLOTE        VARCHAR(06);
DECLARE @V_DTINICCTBL        DATETIME;
DECLARE @V_DTFINACCTBL       DATETIME;
DECLARE @OLD_CDEMPRESA       VARCHAR(2);
DECLARE @OLD_CDFILIAL        VARCHAR(4) 
DECLARE @OLD_DTBAIXAREC      DATETIME;
DECLARE @OLD_NRBAIXAREC      VARCHAR(10);
DECLARE @OLD_IDSTATUSCTBREC  VARCHAR(01);
DECLARE @NEW_IDSTATUSCTBREC  VARCHAR(01);
DECLARE @V_IDTPGERACAOCONT   VARCHAR(01);
DECLARE @V_INSERTED          INT;
DECLARE @V_DELETED           INT;
BEGIN
   SELECT @V_IDTPGERACAOCONT = IDTPGERACAOCONT FROM PARAMCTBL;
                                                                                                          
   IF @V_IDTPGERACAOCONT <> 'O' BEGIN
                                  
      DECLARE C_BAIXARECEBIDA CURSOR FOR
         SELECT CDEMPRESA,  CDFILIAL, 
                DTBAIXAREC, NRBAIXAREC, IDSTATUSCTBREC
           FROM DELETED;
      OPEN C_BAIXARECEBIDA;
      
      FETCH NEXT FROM C_BAIXARECEBIDA INTO @OLD_CDEMPRESA, @OLD_CDFILIAL, @OLD_DTBAIXAREC, @OLD_NRBAIXAREC, @OLD_IDSTATUSCTBREC;
                                                                                                   
      WHILE (@@FETCH_STATUS = 0) BEGIN

      SELECT @V_DTINICCTBL = DTINICCTBL, @V_DTFINACCTBL = DTFINACCTBL
        FROM CONTOPECTBL
       WHERE CDEMPRESA = @OLD_CDEMPRESA;

      SELECT @V_INSERTED = COUNT(*) FROM INSERTED;

      SELECT @V_DELETED = COUNT(*) FROM DELETED;

         IF ((@V_DELETED <> 0) AND (@V_INSERTED = 0)) BEGIN
            IF ((@OLD_DTBAIXAREC >= @V_DTINICCTBL) AND (@OLD_DTBAIXAREC <= @V_DTFINACCTBL)) BEGIN

               DECLARE C_RELACBRECLANLOT CURSOR FOR
                  SELECT MAX(CDLOTE) AS CDLOTE, MAX(NRLANCLOTE) AS NRLANCLOTE
                    FROM RELACBRECLANLOT
                   WHERE  CDFILIAL = @OLD_CDFILIAL
                     AND  NRBAIXAREC = @OLD_NRBAIXAREC;
               OPEN C_RELACBRECLANLOT;

               FETCH NEXT FROM C_RELACBRECLANLOT INTO @V_CDLOTE, @V_NRLANCLOTE;

               WHILE (@@FETCH_STATUS = 0) BEGIN

                  /* DELETA O LANCLOTE DA BAIXA*/

                  DELETE FROM RELACBRECLANLOT
                   WHERE CDEMPRESA  = @OLD_CDEMPRESA
                     AND NRLANCLOTE = @V_NRLANCLOTE
                     AND CDFILIAL   = @OLD_CDFILIAL
                     AND NRBAIXAREC = @OLD_NRBAIXAREC;

                  DELETE FROM LANCLOTE
                   WHERE CDEMPRESA  = @OLD_CDEMPRESA
                     AND CDLOTE     = @V_CDLOTE
                     AND NRLANCLOTE = @V_NRLANCLOTE;

                  EXEC REVERTE_LOTE @OLD_CDEMPRESA, @V_CDLOTE;

                  FETCH NEXT FROM C_RELACBRECLANLOT INTO @V_CDLOTE, @V_NRLANCLOTE;
               END;
               CLOSE C_RELACBRECLANLOT;
               DEALLOCATE C_RELACBRECLANLOT;
            END
            ELSE BEGIN
              RAISERROR('Excluso no permitida, data da baixa a receber fora do perodo de integrao financeiro.', 16, 1);
            END;
            FETCH NEXT FROM C_RELACBRECLANLOT INTO @V_CDLOTE, @V_NRLANCLOTE;
         END;
         FETCH NEXT FROM C_BAIXARECEBIDA INTO @OLD_CDEMPRESA, @OLD_CDFILIAL, @OLD_DTBAIXAREC, @OLD_NRBAIXAREC, @OLD_IDSTATUSCTBREC;
      END;
      CLOSE C_BAIXARECEBIDA;
      DEALLOCATE C_BAIXARECEBIDA;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'STATUS_LOTECTB_BAIXARECEBIDA','5.09.000';
GO