var Est93000_DigitacaoInventarioCego_Controller = function(templateManager, ScreenService, MessageService, General, Colors, EstUtil, ZHPromise, ZhFilterPreferences, localStorageEngine, Est93000_DigitacaoInventarioCego_Services, ValidacoesEstoque_Service) {

    //Inventory Widget Functions

    this.setFilterParams = function(widget, preference = null) {
        Est93000_DigitacaoInventarioCego_Services.getDtProcessa().then((dtProcessa)=>{
            let filtro = [];
            
            filtro = [
                {
                    "name": "CDFILIAL",
                    "operator": "=",
                    "value": "FILIAL_LOGADA"
                },
                {
                    "name": "DTCONTAGEM",
                    "operator": "BETWEEN",
                    "value": [dtProcessa, General.today()]
                }
            ];
            widget.dataSourceFilter = filtro;
            widget.reload();
        });
    };

    this.onAdd = function(widget) {
        const widgetInventory = widget.getParent();
        widget.newRow();
        widget.currentRow.CDFILIAL = widgetInventory.currentRow.CDFILIAL;
        widget.currentRow.CDFILIMOVI = widgetInventory.currentRow.CDFILIAL;
        widget.currentRow.CDALMOXARIFE = widgetInventory.currentRow.CDALMOXARIFE;
        widget.currentRow.CDLOCALESTOQ = widgetInventory.currentRow.CDLOCALESTOQ;
        widget.currentRow.DTCONTAGEM = widgetInventory.currentRow.DTCONTAGEM;
    };

    this.onSaveHandler = function(widget) {

        const onSave = (widget, row, inlineEdit) => {
            Est93000_DigitacaoInventarioCego_Services.save(row).then((saved) => {
                widget.getParent().currentRow.IDSITESTCEGO = saved.dataset.inventory.IDSITESTCEGO;
                General.setEnableAction('concluir', widget.name);
                widget.reload();
                if (inlineEdit) widget.list();
                else ScreenService.goBack();
            }).catch(error => {
                if (error.data) ScreenService.showMessage(error.data.error);
                else ScreenService.showMessage(error);
            });
        };

        if (widget.mode === 'inline_edit') {

            let filteredRows = widget.dataSource.data.filter(function(row) {
                return row.changed === true && (!row.__is_new || this.rowEditedInline(row));
            });
            filteredRows.push({ 'inlineEdit': true });

            onSave(widget, filteredRows, true);
        }
        else {
            if (widget.isNewRow()) {
                let row = widget.currentRow;
                if (!widget.isValid()) return;
                ValidacoesEstoque_Service.consultaCustoQuantidadeProduto(row.CDFILIAL, row.CDPRODUTO, row.DTCONTAGEM, '', row.CDALMOXARIFE, row.CDLOCALESTOQ, row.NRLOTEESTQ, row.NRSUBLOTE).then((success) => {
                    if (success.dataset.consultaCustoQuantidadeProduto.VRCUSTOPROD > 0) {
                        widget.currentRow.inlineEdit = false;
                        onSave(widget, widget.currentRow, false);
                    }
                    else {
                        return MessageService.showMessageByCode("BLOCK_SEM_CUSTO_MEDIO");
                    }
                });
            }
            else {
                widget.currentRow.inlineEdit = false;
                onSave(widget, widget.currentRow, false);
            }
        }
    };

    this.onDeleteHandler = function(widget) {
        return General.deleteCrud(widget);
    };

    this.onConcludeDigitation = function(widget) {
        const IDSITESTCEGO = widget.getParent().currentRow.IDSITESTCEGO;
        if (IDSITESTCEGO === 'ED') {
            MessageService.confirmMessageByCode("DIGITATION_CONFIRMATION").then(_ => {
                Est93000_DigitacaoInventarioCego_Services.onConcludeDigitation(widget.getParent().currentRow).then((saved) => {
                    ScreenService.goBack();
                    widget.getParent().reload();
                }).catch(error => {
                    if (error.data) ScreenService.showMessage(error.data.error);
                    else ScreenService.showMessage(error);
                });
            });
        }
    };

    //Support Functions

    this.rowEditedInline = function(row) {
        let boolEdited = false;

        $.each(row, function(index, value) {
            if (row.hasOwnProperty('changed_' + index)) {
                boolEdited = true;
            }
        });

        return boolEdited;
    };

    this.ActionsHandler = function(widget) {
        const IDGERITINVCEGPR = widget.currentRow.IDGERITINVCEGPR;
        const IDSITESTCEGO = widget.getParent().currentRow.IDSITESTCEGO;

        if (IDSITESTCEGO === 'DG') {
            General.setDisableAction('editar', widget.name);
            General.setDisableAction('delete', widget.name);
            General.setDisableAction('Novo', widget.name);

            General.setDisableAction('concluir', widget.name);

            widget.getField("QTINVENTESTCEGO").inlineEditable = false;
        }
        else {
            if (IDGERITINVCEGPR === 'E') {
                General.setEnableAction('delete', widget.name);
            }
            else {
                General.setDisableAction('delete', widget.name);
            }

            if (IDSITESTCEGO === 'ED') {
                General.setEnableAction('concluir', widget.name);
            }
            else {
                General.setDisableAction('concluir', widget.name);
            }

            General.setEnableAction('editar', widget.name);
            General.setEnableAction('Novo', widget.name);
            widget.getField("QTINVENTESTCEGO").inlineEditable = "number";
            widget.redraw();
        }
    };

    this.IconHandler = function(widget) {
        let data = widget.dataSource.data;
        return data.map(row => {
            row.icon = row.QTINVENTESTCEGO == 0 ? "⚠" : "";
        });
    };
};
Configuration(function(ContextRegister) {
    ContextRegister.register('Est93000_DigitacaoInventarioCego_Controller', Est93000_DigitacaoInventarioCego_Controller);
});
